﻿using DocumentFormat.OpenXml;
using GrapeCity.Documents.Drawing;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Text;
using GrapeCity.Documents.Word;
using GrapeCity.Documents.Word.Layout;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.IO.Compression;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices.ComTypes;
using System.Web;
using System.Web.Mvc;
using Font = GrapeCity.Documents.Text.Font;

namespace WebApplication1.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            GcWordDocument word = new GcWordDocument();
            var path = Server.MapPath("~");

            word.Load(Path.Combine(path, "AR_template.docx"));
            GcPdfDocument pdf = new GcPdfDocument();
            var fields = word.Body.Where(x => x.GetType() == typeof(FieldChar)).Cast<FieldChar>().ToList();

           
          
            foreach (var field in fields)
            {
                if (field.Type == FieldCharType.Begin)
                {
                    var code = (field.Owner as ComplexField).Code;
                    if (code.Contains(" KEYWORDS"))
                    {
                       

                        var imgSize = 100; //Change this property to adjust image Size
                        var par = (field.ParentContent as Run).ParentContent as Paragraph;
                        par.GetRange().Runs.Add();
                        //C1
                        #region Load Image from External Sites
                        var _path = @"https://images.g2crowd.com/uploads/product/image/large_detail/large_detail_26f3682cca12d5731ad87ce6a0313183/wijmo.jpg";
                        WebClient client = new WebClient();
                        byte[] content = client.DownloadData(_path);
                        #endregion
                        var pic1 = par.GetRange().Runs.Last.GetRange().Pictures.Add();
                        pic1.ImageData.SetImage(content, "jpg/JPG");
                        pic1.Size.Width.Value = imgSize;
                        pic1.Size.Height.Value = imgSize;
                        par.GetRange().Runs.Add();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.Add("C1");
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();

                        //Spread
                        var pic2 = par.GetRange().Runs.Last.GetRange().Pictures.Add();
                        pic2.ImageData.SetImage(System.IO.File.ReadAllBytes(Path.Combine(path, "Spread.png")), "png/png");
                        pic2.Size.Width.Value = imgSize;
                        pic2.Size.Height.Value = imgSize;
                        par.GetRange().Runs.Add();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.Add("Spread");
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();

                        //GcDocs
                        var pic3 = par.GetRange().Runs.Last.GetRange().Pictures.Add();
                        pic3.ImageData.SetImage(System.IO.File.ReadAllBytes(Path.Combine(path, "GcDocs.png")), "png/png");
                        pic3.Size.Width.Value = imgSize;
                        pic3.Size.Height.Value = imgSize;
                        par.GetRange().Runs.Add();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.Add("GcDocs");
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();

                        //AR
                        var pic4 = par.GetRange().Runs.Last.GetRange().Pictures.Add();
                        pic4.ImageData.SetImage(System.IO.File.ReadAllBytes(Path.Combine(path, "AR.png")), "png/png");
                        pic4.Size.Width.Value = imgSize;
                        pic4.Size.Height.Value = imgSize;
                        par.GetRange().Runs.Add();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.Add("AR");
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();

                        //Spread
                        var pic5 = par.GetRange().Runs.Last.GetRange().Pictures.Add();
                        pic5.ImageData.SetImage(System.IO.File.ReadAllBytes(Path.Combine(path, "Wijmo.png")), "png/png");
                        pic5.Size.Width.Value = imgSize;
                        pic5.Size.Height.Value = imgSize;
                        par.GetRange().Runs.Add();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.Add("Wijmo");
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        par.GetRange().Runs.Last.GetRange().Texts.AddBreak();
                        field.Owner.Delete();
                    }
                }
            }
            MemoryStream ms = new MemoryStream();
            //word.Save(ms);

            ///GCWord to PDF
            using (var layout = new GcWordLayout(word))
            {

                layout.SaveAsPdf(ms);

            }


            ms.Position = 0;
            return File(ms, "application/pdf");
            
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";
            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}